net.sf.saxon.option.xom

## Class XOMNodeWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper
  - - net.sf.saxon.option.xom.XOMNodeWrapper

- All Implemented Interfaces:
    Source, PullEvent, Item, NodeInfo, Sequence, SteppingNode, SiblingCountingNode, VirtualNode
  Direct Known Subclasses:
    XOMDocumentWrapper

      public class XOMNodeWrapper
      extends AbstractNodeWrapper
      implements VirtualNode, SiblingCountingNode, SteppingNode

  A node in the XML parse tree representing an XML element, character content, or attribute.

  This is the implementation of the NodeInfo interface used as a wrapper for XOM nodes.
  Author:
    Michael H. Kay, Wolfgang Hoschek (ported net.sf.saxon.jdom to XOM)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected XOMDocumentWrapper` | `docWrapper`
    `protected int` | `index`
    `protected Node` | `node`
    `protected short` | `nodeKind`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `XOMNodeWrapper(Node node, XOMNodeWrapper parent, int index)` This constructor is protected: nodes should be created using the wrap factory method on the XOMDocumentWrapper class

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AtomicSequence` | `atomize()` Get the typed value.
    `int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
    `int` | `comparePosition(NodeInfo other)` Determine the relative position of this node and another node, in document order, distinguishing whether the first node is a preceding, following, descendant, ancestor, or the same node as the second.
    `void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter (deep copy)
    `void` | `delete()` Delete this node (that is, detach it from its parent)
    `boolean` | `equals(Object other)` The equals() method compares nodes for identity.
    `void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node.
    `String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
    `String` | `getBaseURI()` Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `int` | `getColumnNumber()` Get column number
    `Configuration` | `getConfiguration()` Get the configuration
    `NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
    `String` | `getDisplayName()` Get the display name of this node.
    `long` | `getDocumentNumber()` Get the document number of the document containing this node.
    `DocumentInfo` | `getDocumentRoot()` Get the root node, if it is a document node.
    `int` | `getFingerprint()` Get fingerprint.
    `SteppingNode` | `getFirstChild()` Get the first child of this node
    `int` | `getLineNumber()` Get line number
    `String` | `getLocalPart()` Get the local part of the name of this node.
    `int` | `getNameCode()` Get name code.
    `NamePool` | `getNamePool()` Get the name pool for this node
    `SteppingNode` | `getNextSibling()` Get the next sibling of this node
    `int` | `getNodeKind()` Return the type of node.
    `SteppingNode` | `getParent()` Get the NodeInfo object representing the parent of this node
    `String` | `getPrefix()` Get the prefix of the name of the node.
    `SteppingNode` | `getPreviousSibling()` Get the previous sibling of this node
    `NodeInfo` | `getRoot()` Get the root node of the tree containing this node
    `SchemaType` | `getSchemaType()` Get the type annotation of this node, if any.
    `int` | `getSiblingPosition()` Get the index position of this node among its siblings (starting from 0)
    `String` | `getStringValue()` Return the string value of the node.
    `CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
    `SteppingNode` | `getSuccessorElement(SteppingNode anchor, String uri, String local)` Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
    `String` | `getSystemId()` Get the System ID for the node.
    `int` | `getTypeAnnotation()` Get the type annotation
    `Object` | `getUnderlyingNode()` Get the underlying XOM node, to implement the VirtualNode interface
    `String` | `getURI()` Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` Determine whether the node has any children.
    `int` | `hashCode()` The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `boolean` | `isId()` Determine whether this node has the is-id property
    `boolean` | `isIdref()` Determine whether this node has the is-idref property
    `boolean` | `isNilled()` Determine whether the node has the is-nilled property
    `boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
    `SequenceIterator` | `iterate()` To implement `Sequence`, this method returns a singleton iterator that delivers this item in the form of a sequence
    `protected AxisIterator<NodeInfo>` | `iterateAttributes(NodeTest nodeTest)` Return an iteration over the nodes reached by the given axis from this node // * @param axisNumber the axis to be used
    `protected AxisIterator<NodeInfo>` | `iterateChildren(NodeTest nodeTest)` Return an iterator over the children of this node.
    `protected AxisIterator<NodeInfo>` | `iterateDescendants(NodeTest nodeTest, boolean includeSelf)` Return an iterator over the descendants of this node.
    `protected AxisIterator<NodeInfo>` | `iterateSiblings(NodeTest nodeTest, boolean forwards)` Return an iterator over the siblings of this node.
    `protected XOMNodeWrapper` | `makeWrapper(Node node, XOMDocumentWrapper docWrapper)` Factory method to wrap a XOM node with a wrapper that implements the Saxon NodeInfo interface.
    `protected XOMNodeWrapper` | `makeWrapper(Node node, XOMDocumentWrapper docWrapper, XOMNodeWrapper parent, int index)` Factory method to wrap a XOM node with a wrapper that implements the Saxon NodeInfo interface.
    `void` | `setSystemId(String uri)` Set the system ID.

    - ### Methods inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `getRealNode, head, iterateAxis, iterateAxis`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.tree.wrapper.VirtualNode

      `getRealNode`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `iterateAxis, iterateAxis`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `head`

- - ### Field Detail

    - #### node

          protected Node node

    - #### nodeKind

          protected short nodeKind

    - #### docWrapper

          protected XOMDocumentWrapper docWrapper

    - #### index

          protected int index

  - ### Constructor Detail

    - #### XOMNodeWrapper

          protected XOMNodeWrapper(Node node,
                        XOMNodeWrapper parent,
                        int index)

      This constructor is protected: nodes should be created using the wrap factory method on the XOMDocumentWrapper class
      Parameters:
        `node` - The XOM node to be wrapped
        `parent` - The XOMNodeWrapper that wraps the parent of this node
        `index` - Position of this node among its siblings

  - ### Method Detail

    - #### makeWrapper

          protected final XOMNodeWrapper makeWrapper(Node node,
                                   XOMDocumentWrapper docWrapper)

      Factory method to wrap a XOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The XOM node
        `docWrapper` - The wrapper for the Document containing this node
      Returns:
        The new wrapper for the supplied node

    - #### makeWrapper

          protected final XOMNodeWrapper makeWrapper(Node node,
                                   XOMDocumentWrapper docWrapper,
                                   XOMNodeWrapper parent,
                                   int index)

      Factory method to wrap a XOM node with a wrapper that implements the Saxon NodeInfo interface.
      Parameters:
        `node` - The XOM node
        `docWrapper` - The wrapper for the Document containing this node
        `parent` - The wrapper for the parent of the XOM node
        `index` - The position of this node relative to its siblings
      Returns:
        The new wrapper for the supplied node

    - #### iterate

          public SequenceIterator iterate()

      To implement `Sequence`, this method returns a singleton iterator that delivers this item in the form of a sequence
      Specified by:
        `iterate` in interface `Sequence`
      Overrides:
        `iterate` in class `AbstractNodeWrapper`
      Returns:
        a singleton iterator that returns this item

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration
      Specified by:
        `getConfiguration` in interface `NodeInfo`
      Overrides:
        `getConfiguration` in class `AbstractNodeWrapper`
      Returns:
        the Configuration

    - #### getUnderlyingNode

          public Object getUnderlyingNode()

      Get the underlying XOM node, to implement the VirtualNode interface
      Specified by:
        `getUnderlyingNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getNamePool

          public NamePool getNamePool()

      Get the name pool for this node
      Specified by:
        `getNamePool` in interface `NodeInfo`
      Overrides:
        `getNamePool` in class `AbstractNodeWrapper`
      Returns:
        the NamePool

    - #### getNodeKind

          public int getNodeKind()

      Return the type of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### atomize

          public AtomicSequence atomize()

      Get the typed value.
      Specified by:
        `atomize` in interface `NodeInfo`
      Overrides:
        `atomize` in class `AbstractNodeWrapper`
      Returns:
        the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
      Since:
        8.5

    - #### getTypeAnnotation

          public int getTypeAnnotation()

      Get the type annotation
      Specified by:
        `getTypeAnnotation` in interface `NodeInfo`
      Overrides:
        `getTypeAnnotation` in class `AbstractNodeWrapper`
      Returns:
        the type annotation of the node, under the mask NamePool.FP_MASK, and optionally the bit setting IS_DTD_TYPE in the case of a DTD-derived ID or IDREF/S type (which is treated as untypedAtomic for the purposes of obtaining the typed value).

        For elements and attributes, this is the type annotation as defined in XDM. For document nodes, it should be one of XS_UNTYPED if the document has not been validated, or XS_ANY_TYPE if validation has taken place (that is, if any node in the document has an annotation other than Untyped or UntypedAtomic).

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Overrides:
        `getSchemaType` in class `AbstractNodeWrapper`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### isSameNodeInfo

          public boolean isSameNodeInfo(NodeInfo other)

      Determine whether this is the same node as another node.
      Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `isSameNodeInfo` in interface `NodeInfo`
      Overrides:
        `isSameNodeInfo` in class `AbstractNodeWrapper`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this Node object and the supplied Node object represent the same node in the tree.

    - #### equals

          public boolean equals(Object other)

      The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().
      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `AbstractNodeWrapper`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
      Since:
        8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

    - #### hashCode

          public int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Specified by:
        `hashCode` in interface `NodeInfo`
      Overrides:
        `hashCode` in class `AbstractNodeWrapper`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getSystemId

          public String getSystemId()

      Get the System ID for the node.
      Specified by:
        `getSystemId` in interface `Source`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Overrides:
        `getSystemId` in class `AbstractNodeWrapper`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

    - #### setSystemId

          public void setSystemId(String uri)

      Description copied from class: `AbstractNodeWrapper`
      Set the system ID. Required because NodeInfo implements the JAXP Source interface
      Specified by:
        `setSystemId` in interface `Source`
      Overrides:
        `setSystemId` in class `AbstractNodeWrapper`
      Parameters:
        `uri` - the system ID.

    - #### getBaseURI

          public String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Overrides:
        `getBaseURI` in class `AbstractNodeWrapper`
      Returns:
        the base URI of the node, taking into account xml:base attributes if present

    - #### getLineNumber

          public int getLineNumber()

      Get line number
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Overrides:
        `getLineNumber` in class `AbstractNodeWrapper`
      Returns:
        the line number of the node in its original source document; or -1 if not available

    - #### getColumnNumber

          public int getColumnNumber()

      Get column number
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Overrides:
        `getColumnNumber` in class `AbstractNodeWrapper`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### compareOrder

          public int compareOrder(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### comparePosition

          public int comparePosition(NodeInfo other)

      Determine the relative position of this node and another node, in document order, distinguishing whether the first node is a preceding, following, descendant, ancestor, or the same node as the second.

      The other node must always be in the same tree; the effect of calling this method when the two nodes are in different trees is undefined. If either node is a namespace or attribute node, the method should throw UnsupportedOperationException.
      Specified by:
        `comparePosition` in interface `NodeInfo`
      Overrides:
        `comparePosition` in class `AbstractNodeWrapper`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        `AxisInfo.PRECEDING` if this node is on the preceding axis of the other node; `AxisInfo.FOLLOWING` if it is on the following axis; `AxisInfo.ANCESTOR` if the first node is an ancestor of the second; `AxisInfo.DESCENDANT` if the first is a descendant of the second; `AxisInfo.SELF` if they are the same node.
      Throws:
        `UnsupportedOperationException` - if either node is an attribute or namespace
      Since:
        9.5

    - #### getStringValue

          public String getStringValue()

      Return the string value of the node. The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.
      Specified by:
        `getStringValue` in interface `Item`
      Specified by:
        `getStringValue` in interface `NodeInfo`
      Overrides:
        `getStringValue` in class `AbstractNodeWrapper`
      Returns:
        the string value of the node
      See Also:
        `Item.getStringValueCS()`

    - #### getStringValueCS

          public CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getNameCode

          public int getNameCode()

      Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with &0xfffff, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.
      Specified by:
        `getNameCode` in interface `NodeInfo`
      Overrides:
        `getNameCode` in class `AbstractNodeWrapper`
      Returns:
        an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
      See Also:
        `allocate`

    - #### getFingerprint

          public int getFingerprint()

      Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. A fingerprint of -1 should be returned for a node with no name.
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Overrides:
        `getFingerprint` in class `AbstractNodeWrapper`
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

    - #### getLocalPart

          public String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "".

    - #### getPrefix

          public String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.

    - #### getURI

          public String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for a node with an empty prefix, return an empty string.

    - #### getDisplayName

          public String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Overrides:
        `getDisplayName` in class `AbstractNodeWrapper`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public SteppingNode getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Specified by:
        `getParent` in interface `SteppingNode`
      Returns:
        the parent of this node; null if this node has no parent

    - #### getNextSibling

          public SteppingNode getNextSibling()

      Description copied from interface: `SteppingNode`
      Get the next sibling of this node
      Specified by:
        `getNextSibling` in interface `SteppingNode`
      Returns:
        the next sibling if there is one, or null otherwise

    - #### getPreviousSibling

          public SteppingNode getPreviousSibling()

      Description copied from interface: `SteppingNode`
      Get the previous sibling of this node
      Specified by:
        `getPreviousSibling` in interface `SteppingNode`
      Returns:
        the previous sibling if there is one, or null otherwise

    - #### getFirstChild

          public SteppingNode getFirstChild()

      Description copied from interface: `SteppingNode`
      Get the first child of this node
      Specified by:
        `getFirstChild` in interface `SteppingNode`
      Returns:
        the first child if there is one, or null otherwise

    - #### getSuccessorElement

          public SteppingNode getSuccessorElement(SteppingNode anchor,
                                         String uri,
                                         String local)

      Description copied from interface: `SteppingNode`
      Find the next matching element in document order; that is, the first child element with the required name if there is one; otherwise the next sibling element if there is one; otherwise the next sibling element of the parent, grandparent, etc, up to the anchor element.
      Specified by:
        `getSuccessorElement` in interface `SteppingNode`
      Parameters:
        `anchor` - the root of the tree within which navigation is confined
        `uri` - the required namespace URI, or null if any namespace is acceptable
        `local` - the required local name, or null if any local name is acceptable
      Returns:
        the next element after this one in document order, with the given URI and local name if specified, or null if this is the last node in the document, or the last node within the subtree being navigated

    - #### getSiblingPosition

          public int getSiblingPosition()

      Get the index position of this node among its siblings (starting from 0)
      Specified by:
        `getSiblingPosition` in interface `SiblingCountingNode`
      Returns:
        0 for the first child, 1 for the second child, etc.

    - #### iterateAttributes

          protected AxisIterator<NodeInfo> iterateAttributes(NodeTest nodeTest)

      Return an iteration over the nodes reached by the given axis from this node

      // * @param axisNumber the axis to be used
      Specified by:
        `iterateAttributes` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - A pattern to be matched by the returned nodes
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.

    - #### iterateChildren

          protected AxisIterator<NodeInfo> iterateChildren(NodeTest nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the children of this node. This method is only called after checking that the node is an element or document.
      Specified by:
        `iterateChildren` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the child nodes, in document order.

    - #### iterateSiblings

          protected AxisIterator<NodeInfo> iterateSiblings(NodeTest nodeTest,
                                               boolean forwards)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the siblings of this node. This method is only called after checking that the node is an element, text, comment, or PI node.
      Specified by:
        `iterateSiblings` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned siblings must satisfy
        `forwards` - true for following siblings, false for preceding siblings
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### iterateDescendants

          protected AxisIterator<NodeInfo> iterateDescendants(NodeTest nodeTest,
                                                  boolean includeSelf)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the descendants of this node. This method is only called after checking that the node is an element or document node.
      Specified by:
        `iterateDescendants` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned descendants must satisfy
        `includeSelf` - true if this node is to be included in the result
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### getAttributeValue

          public String getAttributeValue(String uri,
                                 String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Overrides:
        `getAttributeValue` in class `AbstractNodeWrapper`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node of the tree containing this node
      Specified by:
        `getRoot` in interface `NodeInfo`
      Overrides:
        `getRoot` in class `AbstractNodeWrapper`
      Returns:
        the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node

    - #### getDocumentRoot

          public DocumentInfo getDocumentRoot()

      Get the root node, if it is a document node.
      Specified by:
        `getDocumentRoot` in interface `NodeInfo`
      Returns:
        the DocumentInfo representing the containing document.

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.
      Note: the result is equivalent to
      getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `AbstractNodeWrapper`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer to contain a string that uniquely identifies this node, across all documents

    - #### getDocumentNumber

          public long getDocumentNumber()

      Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.
      Specified by:
        `getDocumentNumber` in interface `NodeInfo`
      Overrides:
        `getDocumentNumber` in class `AbstractNodeWrapper`
      Returns:
        the document number of the document containing this node

    - #### copy

          public void copy(Receiver out,
                  int copyOptions,
                  int locationId)
                    throws XPathException

      Copy this node to a given outputter (deep copy)
      Specified by:
        `copy` in interface `NodeInfo`
      Overrides:
        `copy` in class `AbstractNodeWrapper`
      Parameters:
        `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
        `copyOptions` - a selection of the options defined in `CopyOptions`
        `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
      Throws:
        `XPathException` - if any downstream error occurs

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `AbstractNodeWrapper`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Overrides:
        `isId` in class `AbstractNodeWrapper`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Determine whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Overrides:
        `isIdref` in class `AbstractNodeWrapper`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute

    - #### isNilled

          public boolean isNilled()

      Determine whether the node has the is-nilled property
      Specified by:
        `isNilled` in interface `NodeInfo`
      Overrides:
        `isNilled` in class `AbstractNodeWrapper`
      Returns:
        true if the node has the is-nilled property

    - #### delete

          public void delete()
                      throws XPathException

      Delete this node (that is, detach it from its parent)
      Throws:
        `XPathException`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.